//
//  DailyBooth.h
//  Snap!
//
//  Created by Brandon Schlenker on 5/7/11.
//  Copyright 2011 Brandon Schlenker. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "DBConstants.h"
#import <YAJL/YAJL.h>
#import <QuartzCore/QuartzCore.h>
#import "Reachability.h"

@protocol DailyBoothAPIDelegate;

@interface DailyBooth : NSObject {
@private
     BOOL isUploading;
  
}
@property (assign) BOOL isUploading;
- (BOOL)isAuthenticated;
- (BOOL)refreshToken;
- (void)logout;
- (void)authenticate;
- (void)getTokenWithCode:(NSString *)code;
- (void)postPhoto:(NSImage *)photo withComment:(NSString *)comment andDelegate:(id)delegate;
@end

@protocol DailyBoothAPIDelegate <NSObject>

- (void)finishUpload:(id)object;
- (void)finishAuthentication:(id)object;

@end