//
//  DailyBooth.m
//  Snap!
//
//  Created by Brandon Schlenker on 5/7/11.
//  Copyright 2011 Brandon Schlenker. All rights reserved.
//

#import "DailyBooth.h"
#import "ASIFormDataRequest.h"


@implementation DailyBooth
@synthesize isUploading;

- (id)init
{
    self = [super init];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

- (void)logout
{
    [[NSUserDefaults standardUserDefaults] removeObjectForKey:@"oauth_info"];
    [[NSUserDefaults standardUserDefaults] removeObjectForKey:@"oauth_token"];
    [[NSUserDefaults standardUserDefaults] removeObjectForKey:@"user"];
    [[NSNotificationCenter defaultCenter] postNotificationName:@"DAILYBOOTH_DID_LOGOUT" object:nil];   
}

- (BOOL)isConnected
{
    if ([[Reachability reachabilityForInternetConnection] currentReachabilityStatus] == ReachableViaWiFi)
    {
//        NSLog(@"CONNECTED!");
        return YES;
    }
    else
    {
 //       NSLog(@"NOT CONNECTED!");
        return NO;
    }
}

- (void)authenticate
{
    if (![self isConnected])
    {
        return;
    }
    
    NSString *consumer_key = CONSUMER_KEY;
	//NSString *consumer_secret = CONSUMER_SECRET;
	NSString *application_scheme = APPLICATION_SCHEME;
	
    
    NSString *url = [NSString stringWithFormat:@"http://dailybooth.com/oauth/authorize?client_id=%@&redirect_uri=%@"
                     , consumer_key, application_scheme];
//    NSLog(@"%@", url);
    NSString *token =  [[NSUserDefaults standardUserDefaults] stringForKey:@"oauth_token"];
    
    
    if (!token)
    {
        NSURL *authUrl = [NSURL URLWithString: url];
        [[NSWorkspace sharedWorkspace] openURL:authUrl];
    }
}

- (BOOL)isAuthenticated
{
    NSString *token =  [[NSUserDefaults standardUserDefaults] stringForKey:@"oauth_token"];
    if (token)
    {
        NSDictionary *oauthInfo = [[NSUserDefaults standardUserDefaults] dictionaryForKey:@"oauth_info"];
    ///    NSLog(@"ouathInfo %@",oauthInfo);
        NSString *fuckingWeirdDate = [oauthInfo objectForKey:@"expires_at"];
        fuckingWeirdDate = [[fuckingWeirdDate componentsSeparatedByString:@"T"] objectAtIndex:0];
     //   NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
   //     [dateFormatter setDateStyle:NSDateFormatterShortStyle];
        NSDate *expireDate = [NSDate dateWithNaturalLanguageString:fuckingWeirdDate];
        
        NSDate *today = [NSDate date];
        NSTimeInterval dateTime;
        
    //    NSLog(@"%@", fuckingWeirdDate);
        
        dateTime = ([expireDate timeIntervalSinceDate:today] / 86400);  
  //      NSLog(@"Token Expiration: %f", dateTime);
  //      NSLog(@"Token %@", token);
        if(dateTime < 0)
        {
            return [self refreshToken];
        }
        else 
        {   
            return YES;
        }
    }
    else
    {
        return NO;
    }
    
}

- (BOOL)refreshToken
{
    NSDictionary *oauthInfo = [[NSUserDefaults standardUserDefaults] dictionaryForKey:@"oauth_info"];
    NSString *refresh = [oauthInfo objectForKey:@"refresh_token"];
    NSURL *u = [NSURL URLWithString:@"https://dailybooth.com/oauth/token"];
    ASIFormDataRequest *req = [ASIFormDataRequest requestWithURL:u];
    [req setUserInfo:[NSDictionary dictionaryWithObject:@"refresh" forKey:@"type"]];
    [req setPostValue:CONSUMER_KEY forKey:@"client_id"];
    [req setPostValue:CONSUMER_SECRET forKey:@"client_secret"];
    [req setPostValue:@"refresh_token" forKey:@"grant_type"];
    [req setPostValue:refresh forKey:@"refresh_token"];
    [req startSynchronous];
  //  NSLog(@"refresh token %@", [req responseString]);
    NSDictionary *d = [[req responseString] yajl_JSON];
    NSString *token = [d objectForKey:@"oauth_token"];
    NSDictionary *user = [d objectForKey:@"user"];
    if (token)
    {
        [[NSUserDefaults standardUserDefaults] setObject:user forKey:@"user"];
        [[NSUserDefaults standardUserDefaults] setObject:d forKey:@"oauth_info"];
        [[NSUserDefaults standardUserDefaults] setObject:token forKey:@"oauth_token"]; 
        return YES;
    }
    return NO;
}

- (void)getTokenWithCode:(NSString *)code
{
    NSURL *u = [NSURL URLWithString:@"https://dailybooth.com/oauth/token"];
    ASIFormDataRequest *req = [ASIFormDataRequest requestWithURL:u];
    [req setPostValue:CONSUMER_KEY forKey:@"client_id"];
    [req setPostValue:CONSUMER_SECRET forKey:@"client_secret"];
    [req setPostValue:@"authorization_code" forKey:@"grant_type"];
    [req setPostValue:APPLICATION_SCHEME forKey:@"redirect_uri"];
    [req setPostValue:code forKey:@"code"];
    [req startSynchronous];
  ///  NSLog(@"%@",code);
     //   NSLog(@"%@", [req responseString]);
    NSDictionary *d = [[req responseString] yajl_JSON];
    
    NSString *token = [d objectForKey:@"oauth_token"];
    
    if (token)
    {
        NSDictionary *user = [d objectForKey:@"user"];
        [[NSUserDefaults standardUserDefaults] setObject:user forKey:@"user"];
        [[NSUserDefaults standardUserDefaults] setObject:d forKey:@"oauth_info"];
        [[NSUserDefaults standardUserDefaults] setObject:token forKey:@"oauth_token"];
        [[NSNotificationCenter defaultCenter] postNotificationName:@"DAILYBOOTH_DID_LOGIN" object:nil];
    }
    
}

- (void)postPhoto:(NSImage *)photo withComment:(NSString *)comment andDelegate:(id)delegate
{  
    if (![self isConnected])
    {
  //      return;
    }
    
    if (![self isAuthenticated])
    {
        return;
    }
    
    NSURL *url = [NSURL URLWithString:@"https://api.dailybooth.com/v1/pictures.json"];
    ASIFormDataRequest *req = [ASIFormDataRequest requestWithURL:url];
    [req setDelegate:self];
    [req setTimeOutSeconds:30];
    [req setUserInfo:[NSDictionary dictionaryWithObjectsAndKeys:delegate, @"delegate", @"upload", @"type", nil]];
    NSString *oauth = [[NSUserDefaults standardUserDefaults] stringForKey:@"oauth_token"];
    [req setPostValue:oauth forKey:@"oauth_token"]; 
    if (comment)
    {
   //     NSLog(@"BLURB 2 %@", comment);
        [req setPostValue:comment forKey:@"blurb"];
    }
    
    if (photo)
    {
        NSData *data = [photo TIFFRepresentation];
        NSBitmapImageRep *bitmapRep = [NSBitmapImageRep imageRepWithData:data];
        NSData *jpegData = [bitmapRep representationUsingType:NSJPEGFileType properties:nil];
        [req setData:jpegData forKey:@"picture"];
    }
    self.isUploading = YES;
    [req startAsynchronous];
}

- (void)requestFinished:(ASIHTTPRequest *)request
{
    //NSString *responseString = [request responseString];
    id del = [[request userInfo] objectForKey:@"delegate"];
    NSString *type = [[request userInfo] objectForKey:@"type"];
    //NSLog(@"finish upload %@", type);
    if ([type isEqualToString:@"upload"])
    {
        self.isUploading = NO;
        NSError *parseError;
        NSDictionary *d = [[request responseString] yajl_JSONWithOptions:YAJLParserOptionsNone error:&parseError];
        if (!parseError)
        {
            NSString *user = [[d objectForKey:@"user"] objectForKey:@"username"];
            NSString *picID = [d objectForKey:@"picture_id"];
            
            NSString *url = [NSString stringWithFormat:@"http://dailybooth.com/%@/%@", user, picID];
            
            
            if ([[NSUserDefaults standardUserDefaults] boolForKey:@"prefOpenBooth"])
            {
                NSURL *picURL = [NSURL URLWithString:url];
               [[NSWorkspace sharedWorkspace] openURL:picURL];
            }  
            
            if ([[NSUserDefaults standardUserDefaults] boolForKey:@"prefCopyURL"])
            {

            }  
        }
            
        if ([del respondsToSelector:@selector(finishUpload:)])
        {
            [del performSelector:@selector(finishUpload:) withObject:[request responseString]];
        }
    }
}

- (void)requestFailed:(ASIHTTPRequest *)request
{
    NSString *type = [[request userInfo] objectForKey:@"type"];
    NSLog(@"fail upload %@", [request responseString]);
    id del = [[request userInfo] objectForKey:@"delegate"];
    if ([type isEqualToString:@"upload"])
    {
        self.isUploading = NO;
    }
    
    if ([del respondsToSelector:@selector(failedUpload:)])
    {
        [del performSelector:@selector(failedUpload:) withObject:[request error]];
    }
}

- (void)dealloc
{
    [super dealloc];
}

@end
