//
//  SnapCameraVC.h
//  Snap!
//
//  Created by Brandon Schlenker on 6/14/11.
//  Copyright 2011 Brandon Schlenker. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <QTKit/QTKit.h>
#import <QuartzCore/QuartzCore.h>
#import "SnapPhotoCaptureView.h"
#import "NSColor(CGColor).m"
#import "DailyBooth.h"

@protocol SnapCameraVCDelegate;

@interface SnapCameraVC : NSViewController
{
    NSThread *cameraInitThread;
    QTCaptureDeviceInput    *cameraDeviceInput;
    QTCaptureDecompressedVideoOutput		*cameraVideoOutput;
    CVImageBufferRef		_currentImageBuffer;
	QTCaptureSession        *session;
    QTCaptureDevice         *device;
    QTCaptureLayer          *captureLayer;
    NSError                 *qtError;
    CIImage                 *currentImage;
	BOOL					_frameRecieved;
    NSTimer                 *cameraViewTimer;
    NSTimer                 *cameraSnapTimer;
    int                     time;
    
    SnapPhotoCaptureView    *captureView;
    NSButton                *accountButton;
    NSButton                *prefButton;
    NSProgressIndicator     *loadingIndicator;
    DailyBooth *DBApi;
    
    CIFilter *currentFilter;
    int currentFilterType;
    
    
   BOOL		initializing;
   id       delegate;
    BOOL		busy;
}

- (void)setupLayerStyling;
- (void)startCamera;
- (void)stopCamera;
- (IBAction)openDailyBoothSite:(id)sender;
- (IBAction)openPrefs:(id)sender;
- (IBAction)changeFilter:(id)sender;
@property (assign) BOOL		busy;
@property (assign) BOOL		initializing;
@property (assign) id       delegate;
@property (assign) IBOutlet SnapPhotoCaptureView    *captureView;
@property (assign) IBOutlet NSButton                *accountButton;
@property (assign) IBOutlet NSButton                *prefButton;
@property (assign) IBOutlet NSProgressIndicator     *loadingIndicator;

@property (retain) DailyBooth *DBApi;

@end

@protocol SnapCameraVCDelegate <NSObject>

- (void)snapCameraVC:(SnapCameraVC *)cameraVC didTakePicture:(NSImage *)picture;

@end