//
//  SnapCustomStatusItemView.m
//  Snap!
//
//  Created by Brandon Schlenker on 5/7/11.
//  Copyright 2011 Brandon Schlenker. All rights reserved.
//

#import "SnapCustomStatusItemView.h"


@implementation SnapCustomStatusItemView

- (id)initWithFrame:(NSRect)frame controller:(id)del
{
    if (self = [super initWithFrame:frame])
    {
        delegate = del;
        [self registerForDraggedTypes:[NSArray arrayWithObjects:NSTIFFPboardType, NSFilenamesPboardType, nil]];
    }
    return self;
}

- (void)dealloc
{
    delegate = nil;
    [self unregisterDraggedTypes];
    [super dealloc];
}

#pragma mark -
#pragma mark Menu Item Image

- (void)setSuccess:(BOOL)s
{
    showSuccess = YES;
    success = s;
    [self setNeedsDisplay:YES];
}

- (void)setLoading:(BOOL)l
{
    loading = l;
    showSuccess = NO; 
    [self setNeedsDisplay:YES];
}

#pragma mark -
#pragma mark Drawing

- (void)drawRect:(NSRect)rect 
{    

    NSString *s;
    NSImageRep *r;
    
    if (!image)
    {
        image = [[NSImageView alloc] initWithFrame:NSMakeRect(4, 4, 16, 16)];
        [self addSubview:image];
    }
    if (!loading)
    {
        s = [NSString stringWithFormat:@"%@/camera.png", [[NSBundle mainBundle] resourcePath]];
       
    }
    else
    {
        if (showSuccess)
        {
            if (success)
            {
                s = [NSString stringWithFormat:@"%@/menu-success.png", [[NSBundle mainBundle] resourcePath]];
               // r = [NSImageRep imageRepWithContentsOfFile:s];
            }
            else
            {
                s = [NSString stringWithFormat:@"%@/menu-fail.png", [[NSBundle mainBundle] resourcePath]];
               // r = [NSImageRep imageRepWithContentsOfFile:s];
            }
        }
        else
        {
           s = [NSString stringWithFormat:@"%@/menu-upload.png", [[NSBundle mainBundle] resourcePath]];
            //r = [NSImageRep imageRepWithContentsOfFile:s];
            
        }
    }
    if (clicked) 
    {
   //     [[NSColor selectedMenuItemColor] set];
     //   NSRectFill(rect);
      //  s = [NSString stringWithFormat:@"%@/menu-selected.png", [[NSBundle mainBundle] resourcePath]];
    }
    image.image = [[NSImage alloc] initWithContentsOfFile:s];

    //   [r drawInRect:NSMakeRect(6, 3, 17, 17)];

}

#pragma mark -
#pragma mark Mouse Events

- (void)mouseDown:(NSEvent *)event
{
    NSRect frame = [[self window] frame];
//    NSPoint pt = NSMakePoint(NSMidX(frame), NSMinY(frame));
    [delegate toggleWindow:self];
    clicked =  YES;
    [self setNeedsDisplay:YES];
}

- (void)mouseUp:(NSEvent *)theEvent
{
    clicked = NO;
    [self setNeedsDisplay:YES];
}

- (void)mouseExited:(NSEvent *)theEvent
{
    clicked = NO;
    [self setNeedsDisplay:YES];
}

- (void)mouseDragged:(NSEvent *)theEvent
{
    clicked = NO;
    [self setNeedsDisplay:YES];
}

#pragma mark -
#pragma mark Dragging

- (NSDragOperation)draggingEntered:(id < NSDraggingInfo >)sender 
{
	if ([NSImage canInitWithPasteboard:[sender draggingPasteboard]]) {

		return NSDragOperationCopy;
	}
	return NSDragOperationNone;
}

- (BOOL)prepareForDragOperation:(id < NSDraggingInfo >)sender 
{
	return YES;
}

- (BOOL)performDragOperation:(id < NSDraggingInfo >)sender {
	NSPasteboard *pb = [sender draggingPasteboard];
	NSData *imageData = [pb dataForType:NSTIFFPboardType];
	NSString *filename = [[pb propertyListForType:NSFilenamesPboardType] objectAtIndex:0];
    NSLog(@"%@", filename);
	NSImage *image = nil;
	if (imageData) {
		image = [[NSImage alloc] initWithData:imageData];
	} else if (filename) {
		image = [[NSImage alloc] initWithContentsOfURL:[NSURL fileURLWithPath:filename]];
	}
	if (!image)
		return NO;
    
    [delegate snapStatusItemView:self draggedImage:image];
    
	return YES;
}

@end
