//
//  SnapPhotoCaptureView.m
//  Snap!
//
//  Created by Brandon Schlenker on 5/19/11.
//  Copyright 2011 Brandon Schlenker. All rights reserved.
//

#import "SnapPhotoCaptureView.h"
#import "NSColor(CGColor).m"
@implementation SnapPhotoCaptureView
@synthesize delegate, hoverText;

- (id)init
{
    self = [super init];
    if (self) {
        
        
    }
    
    return self;
}

- (void)awakeFromNib
{
    NSTrackingArea *a = [[NSTrackingArea alloc] initWithRect:self.frame options:NSTrackingMouseEnteredAndExited|NSTrackingActiveInActiveApp owner:self userInfo:nil];
    [self addTrackingArea:a];
    [a release];
    
    if (!hoverText)
    {
        hoverText = [[NSTextField alloc] initWithFrame:NSMakeRect(0, 0, self.frame.size.width, 20)];
        [hoverText setEditable:NO];
        [hoverText setSelectable:NO];
        [hoverText setDrawsBackground:YES];
        [hoverText setBackgroundColor:[NSColor blackColor]];
        [hoverText setTextColor:[NSColor whiteColor]];
        [hoverText setFont:[NSFont boldSystemFontOfSize:11.9]];
        [hoverText setBezeled:NO];
        [hoverText setAlphaValue:0];
        [self addSubview:hoverText];
        [self resetText];
    }  

}

- (void)setHoverAlwaysVisible:(BOOL)visible
{
    hoverVisible = visible;
    
    if (visible)
    {
        [self mouseEntered:nil];
    }
    else
    {
        [self mouseExited:nil];
    }
}

- (void)mouseUp:(NSEvent *)theEvent
{
    if([theEvent clickCount] == 1)
    {
        [delegate captureViewDidClick:self];
    }
    else if([theEvent clickCount] == 2)
    {
        [delegate captureViewDidDoubleClick:self];
    }
}

- (void)mouseEntered:(NSEvent *)theEvent
{
 
        [NSAnimationContext beginGrouping];
        [[NSAnimationContext currentContext] setDuration:0.3];
        [[hoverText animator] setAlphaValue:.6];
//        [hoverText setNeedsDisplay:YES];
        
        [NSAnimationContext endGrouping];
}

- (void)mouseExited:(NSEvent *)theEvent
{
    if (hoverText)
    {
        if (!hoverVisible)
        {
            
            [NSAnimationContext beginGrouping];
            [[NSAnimationContext currentContext] setDuration:0.3];
            [[hoverText animator] setAlphaValue:0.0];
            //        [hoverText setNeedsDisplay:YES];
            
            [NSAnimationContext endGrouping];
            [self performSelector:@selector(resetText) withObject:nil afterDelay:.31];
            /*[hoverText removeFromSuperview];
            [hoverText release];
            hoverText = nil;*/
        }
    }
}

- (void)resetText
{
    hoverText.stringValue = @" Click to start timer. Double click to skip.";

}

@end
