//
//  SnapUploadVC.h
//  Snap!
//
//  Created by Brandon Schlenker on 6/14/11.
//  Copyright 2011 Brandon Schlenker. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "DailyBooth.h"

@protocol SnapUploadVCDelegate;

@interface SnapUploadVC : NSViewController
{
    DailyBooth *DBApi;
    id   delegate;
    NSTextView *commentTextField;
    NSImageView *imageView;
}

- (void)setupLayerStyling;
- (IBAction)uploadPhoto:(id)sender;
- (IBAction)retakePhoto:(id)sender;

@property (retain) DailyBooth *DBApi;

@property (assign) id   delegate;
@property (assign) IBOutlet NSTextView *commentTextField;
@property (assign) IBOutlet NSImageView *imageView;
@end

@protocol SnapUploadVCDelegate <NSObject>
- (void)snapUploadVC:(SnapUploadVC *)uploadVC didSendPicture:(NSImage *)picture;
- (void)snapUploadVC:(SnapUploadVC *)uploadVC didFinishUploadWithResult:(NSString *)result;
- (void)snapUploadVC:(SnapUploadVC *)uploadVC didFailUploadWithResult:(NSError *)result;
@end