//
//  SnapUploadVC.m
//  Snap!
//
//  Created by Brandon Schlenker on 6/14/11.
//  Copyright 2011 Brandon Schlenker. All rights reserved.
//

#import "SnapUploadVC.h"

@implementation SnapUploadVC
@synthesize DBApi, delegate, commentTextField, imageView;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

- (void)setupLayerStyling
{
    CALayer *l;
    
    l = self.imageView.layer;
    
    [l setCornerRadius:3.0f];
    [l setMasksToBounds:YES];
    [l setBorderWidth:0.75f];
    NSColor *color = [NSColor colorWithCalibratedWhite:0.0 alpha:0.5];
    [l setBorderColor:[color CGColor]];
}

- (IBAction)uploadPhoto:(id)sender
{
    if ([self.DBApi isAuthenticated])
    {
        NSLog(@"BLURB 1 %@", [commentTextField string]);
        [self.DBApi postPhoto:self.imageView.image withComment:[commentTextField string] andDelegate:self];
        [delegate snapUploadVC:self didSendPicture:self.imageView.image];
        [commentTextField setString:@""];
    }
    else
    {
        [DBApi authenticate];
    }
}

- (void)finishUpload:(id)object
{
    [delegate snapUploadVC:self didFinishUploadWithResult:object];
}

- (void)failedUpload:(id)object
{
    NSLog(@"%@", object);
    [delegate snapUploadVC:self didFailUploadWithResult:object];
}

- (IBAction)retakePhoto:(id)sender
{
    [delegate retakePhoto:sender];
}


@end
